## ffmpeg 4.2.7

=== libavcodec/Makefile ===
NAME = avcodec
DESC = FFmpeg codec library

HEADERS = ac3_parser.h                                                  \
          adts_parser.h                                                 \
          avcodec.h                                                     \
          avdct.h                                                       \
          avfft.h                                                       \
          d3d11va.h                                                     \
          dirac.h                                                       \
          dv_profile.h                                                  \
          dxva2.h                                                       \
          jni.h                                                         \
          mediacodec.h                                                  \
          qsv.h                                                         \
          vaapi.h                                                       \
          vdpau.h                                                       \
          version.h                                                     \
          videotoolbox.h                                                \
          vorbis_parser.h                                               \
          xvmc.h                                                        \

OBJS = ac3_parser.o                                                     \
       adts_parser.o                                                    \
       allcodecs.o                                                      \
       avdct.o                                                          \
       avpacket.o                                                       \
       avpicture.o                                                      \
       bitstream.o                                                      \
       bitstream_filter.o                                               \
       bitstream_filters.o                                              \
       bsf.o                                                            \
       codec_desc.o                                                     \
       d3d11va.o                                                        \
       decode.o                                                         \
       dirac.o                                                          \
       dv_profile.o                                                     \
       encode.o                                                         \
       imgconvert.o                                                     \
       jni.o                                                            \
       mathtables.o                                                     \
       mediacodec.o                                                     \
       mpeg12framerate.o                                                \
       options.o                                                        \
       mjpegenc_huffman.o                                               \
       parser.o                                                         \
       parsers.o                                                        \
       profiles.o                                                       \
       qsv_api.o                                                        \
       raw.o                                                            \
       utils.o                                                          \
       vorbis_parser.o                                                  \
       xiph.o                                                           \

# subsystems
OBJS-$(CONFIG_AANDCTTABLES)            += aandcttab.o
OBJS-$(CONFIG_AC3DSP)                  += ac3dsp.o ac3.o ac3tab.o
OBJS-$(CONFIG_ADTS_HEADER)             += adts_header.o mpeg4audio.o
OBJS-$(CONFIG_AMF)                     += amfenc.o
OBJS-$(CONFIG_AUDIO_FRAME_QUEUE)       += audio_frame_queue.o
OBJS-$(CONFIG_AUDIODSP)                += audiodsp.o
OBJS-$(CONFIG_BLOCKDSP)                += blockdsp.o
OBJS-$(CONFIG_BSWAPDSP)                += bswapdsp.o
OBJS-$(CONFIG_CABAC)                   += cabac.o
OBJS-$(CONFIG_CBS)                     += cbs.o
OBJS-$(CONFIG_CBS_AV1)                 += cbs_av1.o
OBJS-$(CONFIG_CBS_H264)                += cbs_h2645.o h2645_parse.o
OBJS-$(CONFIG_CBS_H265)                += cbs_h2645.o h2645_parse.o
OBJS-$(CONFIG_CBS_JPEG)                += cbs_jpeg.o
OBJS-$(CONFIG_CBS_MPEG2)               += cbs_mpeg2.o
OBJS-$(CONFIG_CBS_VP9)                 += cbs_vp9.o
OBJS-$(CONFIG_CRYSTALHD)               += crystalhd.o
OBJS-$(CONFIG_DCT)                     += dct.o dct32_fixed.o dct32_float.o
OBJS-$(CONFIG_ERROR_RESILIENCE)        += error_resilience.o
OBJS-$(CONFIG_EXIF)                    += exif.o tiff_common.o
OBJS-$(CONFIG_FAANDCT)                 += faandct.o
OBJS-$(CONFIG_FAANIDCT)                += faanidct.o
OBJS-$(CONFIG_FDCTDSP)                 += fdctdsp.o jfdctfst.o jfdctint.o
FFT-OBJS-$(CONFIG_HARDCODED_TABLES)    += cos_tables.o cos_fixed_tables.o
OBJS-$(CONFIG_FFT)                     += avfft.o fft_fixed.o fft_float.o \
                                          fft_fixed_32.o fft_init_table.o \
                                          $(FFT-OBJS-yes)
OBJS-$(CONFIG_FLACDSP)                 += flacdsp.o
OBJS-$(CONFIG_FMTCONVERT)              += fmtconvert.o
OBJS-$(CONFIG_GOLOMB)                  += golomb.o
OBJS-$(CONFIG_H263DSP)                 += h263dsp.o
OBJS-$(CONFIG_H264CHROMA)              += h264chroma.o
OBJS-$(CONFIG_H264DSP)                 += h264dsp.o h264idct.o
OBJS-$(CONFIG_H264PARSE)               += h264_parse.o h2645_parse.o h264_ps.o
OBJS-$(CONFIG_H264PRED)                += h264pred.o
OBJS-$(CONFIG_H264QPEL)                += h264qpel.o
OBJS-$(CONFIG_HEVCPARSE)               += hevc_parse.o h2645_parse.o hevc_ps.o hevc_sei.o hevc_data.o
OBJS-$(CONFIG_HPELDSP)                 += hpeldsp.o
OBJS-$(CONFIG_HUFFMAN)                 += huffman.o
OBJS-$(CONFIG_HUFFYUVDSP)              += huffyuvdsp.o
OBJS-$(CONFIG_HUFFYUVENCDSP)           += huffyuvencdsp.o
OBJS-$(CONFIG_IDCTDSP)                 += idctdsp.o simple_idct.o jrevdct.o
OBJS-$(CONFIG_IIRFILTER)               += iirfilter.o
OBJS-$(CONFIG_MDCT15)                  += mdct15.o
OBJS-$(CONFIG_INTRAX8)                 += intrax8.o intrax8dsp.o msmpeg4data.o
OBJS-$(CONFIG_IVIDSP)                  += ivi_dsp.o
OBJS-$(CONFIG_JNI)                     += ffjni.o jni.o
OBJS-$(CONFIG_JPEGTABLES)              += jpegtables.o
OBJS-$(CONFIG_LLAUDDSP)                += lossless_audiodsp.o
OBJS-$(CONFIG_LLVIDDSP)                += lossless_videodsp.o
OBJS-$(CONFIG_LLVIDENCDSP)             += lossless_videoencdsp.o
OBJS-$(CONFIG_LPC)                     += lpc.o
OBJS-$(CONFIG_LSP)                     += lsp.o
OBJS-$(CONFIG_LZF)                     += lzf.o
OBJS-$(CONFIG_MDCT)                    += mdct_fixed.o mdct_float.o mdct_fixed_32.o
OBJS-$(CONFIG_ME_CMP)                  += me_cmp.o
OBJS-$(CONFIG_MEDIACODEC)              += mediacodecdec_common.o mediacodec_surface.o mediacodec_wrapper.o mediacodec_sw_buffer.o
OBJS-$(CONFIG_MPEG_ER)                 += mpeg_er.o
OBJS-$(CONFIG_MPEGAUDIO)               += mpegaudio.o
OBJS-$(CONFIG_MPEGAUDIODSP)            += mpegaudiodsp.o                \
                                          mpegaudiodsp_data.o           \
                                          mpegaudiodsp_fixed.o          \
                                          mpegaudiodsp_float.o
OBJS-$(CONFIG_MPEGAUDIOHEADER)         += mpegaudiodecheader.o mpegaudiodata.o
OBJS-$(CONFIG_MPEGVIDEO)               += mpegvideo.o mpegvideodsp.o rl.o \
                                          mpegvideo_motion.o mpegutils.o \
                                          mpegvideodata.o mpegpicture.o
OBJS-$(CONFIG_MPEGVIDEOENC)            += mpegvideo_enc.o mpeg12data.o  \
                                          motion_est.o ratecontrol.o    \
                                          mpegvideoencdsp.o
OBJS-$(CONFIG_MSS34DSP)                += mss34dsp.o
OBJS-$(CONFIG_NVENC)                   += nvenc.o
OBJS-$(CONFIG_PIXBLOCKDSP)             += pixblockdsp.o
OBJS-$(CONFIG_QPELDSP)                 += qpeldsp.o
OBJS-$(CONFIG_QSV)                     += qsv.o
OBJS-$(CONFIG_QSVDEC)                  += qsvdec.o
OBJS-$(CONFIG_QSVENC)                  += qsvenc.o
OBJS-$(CONFIG_RANGECODER)              += rangecoder.o
OBJS-$(CONFIG_RDFT)                    += rdft.o
OBJS-$(CONFIG_RV34DSP)                 += rv34dsp.o
OBJS-$(CONFIG_SHARED)                  += log2_tab.o reverse.o
OBJS-$(CONFIG_SINEWIN)                 += sinewin.o sinewin_fixed.o
OBJS-$(CONFIG_SNAPPY)                  += snappy.o
OBJS-$(CONFIG_STARTCODE)               += startcode.o
OBJS-$(CONFIG_TEXTUREDSP)              += texturedsp.o
OBJS-$(CONFIG_TEXTUREDSPENC)           += texturedspenc.o
OBJS-$(CONFIG_TPELDSP)                 += tpeldsp.o
OBJS-$(CONFIG_VAAPI_ENCODE)            += vaapi_encode.o
OBJS-$(CONFIG_VC1DSP)                  += vc1dsp.o
OBJS-$(CONFIG_VIDEODSP)                += videodsp.o
OBJS-$(CONFIG_VP3DSP)                  += vp3dsp.o
OBJS-$(CONFIG_VP56DSP)                 += vp56dsp.o
OBJS-$(CONFIG_VP8DSP)                  += vp8dsp.o
OBJS-$(CONFIG_V4L2_M2M)                += v4l2_m2m.o v4l2_context.o v4l2_buffers.o v4l2_fmt.o
OBJS-$(CONFIG_WMA_FREQS)               += wma_freqs.o
OBJS-$(CONFIG_WMV2DSP)                 += wmv2dsp.o

# decoders/encoders
OBJS-$(CONFIG_ZERO12V_DECODER)         += 012v.o
OBJS-$(CONFIG_A64MULTI_ENCODER)        += a64multienc.o elbg.o
OBJS-$(CONFIG_A64MULTI5_ENCODER)       += a64multienc.o elbg.o
OBJS-$(CONFIG_AAC_DECODER)             += aacdec.o aactab.o aacsbr.o aacps_float.o \
                                          mpeg4audio.o kbdwin.o \
                                          sbrdsp.o aacpsdsp_float.o cbrt_data.o
OBJS-$(CONFIG_AAC_FIXED_DECODER)       += aacdec_fixed.o aactab.o aacsbr_fixed.o aacps_fixed.o \
                                          mpeg4audio.o kbdwin.o \
                                          sbrdsp_fixed.o aacpsdsp_fixed.o cbrt_data_fixed.o
OBJS-$(CONFIG_AAC_ENCODER)             += aacenc.o aaccoder.o aacenctab.o    \
                                          aacpsy.o aactab.o      \
                                          aacenc_is.o \
                                          aacenc_tns.o \
                                          aacenc_ltp.o \
                                          aacenc_pred.o \
                                          psymodel.o mpeg4audio.o kbdwin.o cbrt_data.o
OBJS-$(CONFIG_AASC_DECODER)            += aasc.o msrledec.o
OBJS-$(CONFIG_AC3_DECODER)             += ac3dec_float.o ac3dec_data.o ac3.o kbdwin.o ac3tab.o
OBJS-$(CONFIG_AC3_FIXED_DECODER)       += ac3dec_fixed.o ac3dec_data.o ac3.o kbdwin.o ac3tab.o
OBJS-$(CONFIG_AC3_ENCODER)             += ac3enc_float.o ac3enc.o ac3tab.o \
                                          ac3.o kbdwin.o
OBJS-$(CONFIG_AC3_FIXED_ENCODER)       += ac3enc_fixed.o ac3enc.o ac3tab.o ac3.o
OBJS-$(CONFIG_AGM_DECODER)             += agm.o
OBJS-$(CONFIG_AIC_DECODER)             += aic.o
OBJS-$(CONFIG_ALAC_DECODER)            += alac.o alac_data.o alacdsp.o
OBJS-$(CONFIG_ALAC_ENCODER)            += alacenc.o alac_data.o
OBJS-$(CONFIG_ALIAS_PIX_DECODER)       += aliaspixdec.o
OBJS-$(CONFIG_ALIAS_PIX_ENCODER)       += aliaspixenc.o
OBJS-$(CONFIG_ALS_DECODER)             += alsdec.o bgmc.o mlz.o mpeg4audio.o
OBJS-$(CONFIG_AMRNB_DECODER)           += amrnbdec.o celp_filters.o   \
                                          celp_math.o acelp_filters.o \
                                          acelp_vectors.o             \
                                          acelp_pitch_delay.o
OBJS-$(CONFIG_AMRWB_DECODER)           += amrwbdec.o celp_filters.o   \
                                          celp_math.o acelp_filters.o \

=== debian/changelog ===
ffmpeg (7:4.2.7-0ubuntu0.1) focal-security; urgency=medium

  * SECURITY UPDATE: New upstream bugfix release (LP: #1970674).
    - Fixes CVE-2020-20445, CVE-2020-20446, CVE-2020-20450, CVE-2020-20453,
      CVE-2020-21041, CVE-2020-21688, CVE-2020-21697, CVE-2020-22015,
      CVE-2020-22017, CVE-2020-22019, CVE-2020-22020, CVE-2020-22021,
      CVE-2020-22022, CVE-2020-22023, CVE-2020-22025, CVE-2020-22026,
      CVE-2020-22027, CVE-2020-22028, CVE-2020-22029, CVE-2020-22030,
      CVE-2020-22031, CVE-2020-22032, CVE-2020-22033, CVE-2020-22034,
      CVE-2020-22035, CVE-2020-22036, CVE-2020-22037, CVE-2020-22042,
      CVE-2020-35965, CVE-2021-38114, CVE-2021-38171 and CVE-2021-38291.

 -- Luís Infante da Câmara <luis.infante.da.camara@tecnico.ulisboa.pt>  Wed, 18 May 2022 22:24:26 +0100

ffmpeg (7:4.2.4-1ubuntu0.1) focal-security; urgency=medium

  * SECURITY UPDATE: New upstream bugfix release.
    - Fixes CVE-2019-13312, CVE-2020-12284 and CVE-2020-13904.

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Thu, 16 Jul 2020 12:04:07 -0300

## ffmpeg 4.3

=== libswscale/x86/Makefile ===
$(SUBDIR)x86/swscale_mmx.o: CFLAGS += $(NOREDZONE_FLAGS)

OBJS                            += x86/rgb2rgb.o                        \
                                   x86/swscale.o                        \
                                   x86/yuv2rgb.o                        \

MMX-OBJS                        += x86/hscale_fast_bilinear_simd.o      \

OBJS-$(CONFIG_XMM_CLOBBER_TEST) += x86/w64xmmtest.o

X86ASM-OBJS                     += x86/input.o                          \
                                   x86/output.o                         \
                                   x86/scale.o                          \
                                   x86/rgb_2_rgb.o                      \
                                   x86/yuv_2_rgb.o                      \

=== debian/changelog ===
ffmpeg (7:4.3-3+rpi1) bullseye-staging; urgency=medium

  * Disable testsuite.

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 16 Jul 2020 14:28:50 +0000

ffmpeg (7:4.3-3) unstable; urgency=medium

  * link with dav1d;
    build-depend on libdav1d-dev
  * build-depend on libbrotli-dev
    (as temporary workaround, see bug#964185)

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 03 Jul 2020 17:57:57 +0200

ffmpeg (7:4.3-2) unstable; urgency=medium

  * use debhelper compatibility level 12 (not 11);
    skip dwz for most libraries to avoid error: Unknown DWARF DW_OP_0
  * reduce and simplify shell code in make rules

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 17 Jun 2020 15:15:20 +0200

ffmpeg (7:4.3-1) experimental; urgency=medium

  [ upstream ]
  * new feature release

  [ Jonas Smedegaard ]
  * link with RabbitMQ;
    build-depend on librabbitmq-dev
  * update comments in rules file about omitted linkage
  * stop enable AviSynth: embedded code dropped upstream
  * drop patch 002, applied upstream
  * explicitly reuse symbols files (drop symbolic links),
    to not confuse pkgkde-symbolshelper
  * sort symbols, and move comments to README.source
  * briefly document use of pkgkde-symbolshelper in README.source
  * update symbols, including dropped avfilter symbols
    avfilter_all_channel_layouts avfilter_get_matrix
    (seemingly private and unused anywhere in Debian)

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 16 Jun 2020 19:20:15 +0200

ffmpeg (7:4.2.3-2) unstable; urgency=medium

  * copyright:
    + use License-Grant and License-Reference;
      add lintian overrides (see bug#786450)
    + update coverage
  * stop mention SOFAlizer in libavfilter-extra* long description:
    dropped since upstream release 3.4
  * simplify rules:
    explicitly reuse symbols files (and drop symbolic links)
  * watch: revert to set pgpsigurlmangle
    (not pgpmode=auto: we want to fail if signature file is missing)
  * use pkgkde-symbolshelper;
    build-depend on pkg-kde-tools

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 16 Jun 2020 18:44:49 +0200

ffmpeg (7:4.2.3-1) unstable; urgency=medium

  [ upstream ]
  * new maintenance release

  [ Jonas Smedegaard ]
  * link with Pocket Sphinx where available (see bug#812335);
    build-depend on recent libpocketsphinx-dev (see bug#941377)
  * watch:
    + use file format 4
    + set pgpmode=auto
    + set dversionmangle=auto
    + use pattern strings
    + add usage comment

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 16 Jun 2020 11:58:44 +0200

ffmpeg (7:4.2.2-3) unstable; urgency=medium

  * fix limit libmfx linking to amd64,
    to match availability of the library

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 10 Jun 2020 17:10:49 +0200

ffmpeg (7:4.2.2-2) unstable; urgency=medium

  * link with libsrt;
    build-depend on libsrt-gnutls-dev;
    closes: bug#960140, thanks to Kyle Robbertze
  * add myself as uploader
  * link with libmfx;
    build-depend on libmfx-dev;
    closes: bug#955130, thanks to Tom Yang

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 10 Jun 2020 13:53:47 +0200

=== debian/control ===
Source: ffmpeg
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Andreas Cadhalpun <Andreas.Cadhalpun@googlemail.com>,
 Alexander Strasser <eclipse7@gmx.net>,
 Reinhard Tartler <siretart@tauware.de>,
 Balint Reczey <balint@balintreczey.hu>,
 James Cowgill <jcowgill@debian.org>,
 Jonas Smedegaard <dr@jones.dk>,
Rules-Requires-Root: no
Homepage: https://ffmpeg.org/
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/multimedia-team/ffmpeg.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ffmpeg
Build-Depends-Indep:
# needed to minify the CSS files
 cleancss,
# Autogenerated documentation
 doxygen,
# needed to create the CSS files for the HTML manuals
 node-less,
# generates top level manual page listing
 tree,
Build-Depends:
# needed for dh
 debhelper-compat (= 12),
# for build-profile support
 dpkg-dev (>= 1.17.14),
# --enable-libflite
 flite1-dev,
# --enable-frei0r
 frei0r-plugins-dev <!pkg.ffmpeg.stage1>,
# --enable-ladspa
 ladspa-sdk,
# --enable-libaom
 libaom-dev,
# --enable-libaribb24
 libaribb24-dev,
# --enable-libass
 libass-dev,
# --enable-libbluray
 libbluray-dev,
# TODO: drop when declared by libfreetype-dev (see bug#964185)
 libbrotli-dev,
# --enable-libbs2b
 libbs2b-dev,
# autodetected: external library 'bzlib'
 libbz2-dev,
# --enable-libcaca
 libcaca-dev,
# --enable-libcdio
 libcdio-paranoia-dev,
# --enable-libchromaprint
 libchromaprint-dev <!pkg.ffmpeg.stage1>,
# --enable-libcodec2
 libcodec2-dev,
# --enable-libdav1d
 libdav1d-dev,
# --enable-libdc1394
 libdc1394-22-dev [linux-any],
# --enable-libdrm
 libdrm-dev [linux-any],
# --enable-libfontconfig
 libfontconfig1-dev,
# --enable-libfreetype
 libfreetype6-dev,
# --enable-fribidi
 libfribidi-dev,
# --enable-opengl
 libgl1-mesa-dev,
# --enable-libgme
 libgme-dev,
# --enable-gnutls
 libgnutls28-dev | libgnutls-dev,
# --enable-libgsm
 libgsm1-dev,
# Fails to be detected by configure script, if not also libavc1394-dev is installed.
# --enable-libiec61883
 libiec61883-dev [linux-any],
 libavc1394-dev [linux-any],
# --enable-libjack
 libjack-jackd2-dev,
# --enable-liblensfun (used only in -extra flavor)
 liblensfun-dev,
# --enable-lv2
 liblilv-dev,
# autodetected for the tiff decoder
 liblzma-dev,
# --enable-libmfx
 libmfx-dev [amd64],
# --enable-libmp3lame
 libmp3lame-dev,
# --enable-libmysofa
 libmysofa-dev,
# --enable-openal
 libopenal-dev,
# --enable-omx
 libomxil-bellagio-dev,
# --enable-libopencore_amrnb
 libopencore-amrnb-dev,
# --enable-libopencore_amrwb
 libopencore-amrwb-dev,
# --enable-libopenjpeg
 libopenjp2-7-dev (>= 2.1),
# --enable-libopenmpt
 libopenmpt-dev,
# --enable-libopus
 libopus-dev,
# --enable-pocketsphinx
 libpocketsphinx-dev (>= 0.8+5prealpha+1-7~) [!mipsel !mips64el !s390x],
# --enable-libpulse
 libpulse-dev,
# --enable-librabbitmq
 librabbitmq-dev,
# --enable-librubberband
 librubberband-dev,
# --enable-librsvg
 librsvg2-dev,
# autodetected: protocol 'sctp'
 libsctp-dev [linux-any],
# --enable-sdl2
 libsdl2-dev,
# --enable-libshine
 libshine-dev (>= 3.0.0),
# --enable-libsnappy
 libsnappy-dev,
# --enable-libsoxr
 libsoxr-dev,
# --enable-libspeex
 libspeex-dev,
# --enable-libsrt
 libsrt-gnutls-dev,
# --enable-libssh
 libssh-gcrypt-dev,
# --enable-libtesseract (used only in -extra flavor)
 libtesseract-dev,
# --enable-libtheora
 libtheora-dev,
# --enable-libtwolame
 libtwolame-dev,
# This is not necessary, see explanation in debian/rules.
# # --enable-libv4l2
# libv4l-dev [!hurd-any],
# autodetected: hwaccels 'h263_vaapi, mpeg2_vaapi, vc1_vaapi, h264_vaapi, mpeg4_vaapi, wmv3_vaapi'
 libva-dev (>= 1.3) [!hurd-any],
# autodetected: hwaccels 'h263_vdpau, mpeg2_vdpau, vc1_vdpau, h264_vdpau, mpeg4_vdpau, wmv3_vdpau, mpeg1_vdpau', decoders 'h264_vdpau, mpeg1_vdpau, mpeg4_vdpau, mpeg_vdpau, vc1_vdpau, wmv3_vdpau'
 libvdpau-dev,
# --enable-libvidstab
 libvidstab-dev,
# --enable-libvo_amrwbenc
 libvo-amrwbenc-dev,
# --enable-libvorbis
 libvorbis-dev,
# --enable-libvpx
 libvpx-dev,
# --enable-libwavpack
 libwavpack-dev,
# --enable-libwebp
 libwebp-dev,
# --enable-libx264
 libx264-dev <!pkg.ffmpeg.stage1>,
# --enable-libx265
 libx265-dev (>= 1.8),
# autodetected libxcb-shape
 libxcb-shape0-dev,
# autodetected libxcb-shm
 libxcb-shm0-dev,
# autodetected libxcb-xfixes
 libxcb-xfixes0-dev,
# --enable-libxml2
 libxml2-dev,
# autodetected xlib
 libxv-dev,
# --enable-libxvid
 libxvidcore-dev,
# autodetected: decoder 'mpeg_xvmc'; outdev 'xv'
 libxvmc-dev,
# --enable-libzmq
 libzmq3-dev,
# --enable-libzvbi
 libzvbi-dev,
# --enable-opencl
 ocl-icd-opencl-dev | opencl-dev,
# used to detect libraries
 pkg-config,
# HTML documentation
 texinfo,
# assembler optimizations
 nasm,
 pkg-kde-tools,
# autodetected zlib
 zlib1g-dev

Package: ffmpeg
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 ffmpeg-doc
Breaks: libav-tools (<< 6:12~~),
 qt-faststart (<< 7:2.7.1-3~),
 winff (<< 1.5.5-5~),
Replaces: libav-tools (<< 6:12~~),
 qt-faststart (<< 7:2.7.1-3~)
Description: Tools for transcoding, streaming and playing of multimedia files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This package contains:
  * ffmpeg: a command line tool to convert multimedia files between formats
  * ffplay: a simple media player based on SDL and the FFmpeg libraries
  * ffprobe: a simple multimedia stream analyzer
  * qt-faststart: a utility to rearrange Quicktime files

Package: ffmpeg-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 libjs-bootstrap,
 ${misc:Depends}
Description: Documentation of the FFmpeg multimedia framework
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This package contains the HTML documentation for the FFmpeg multimedia
 framework including the API documentation created by doxygen and the manpages
 for the libraries.

Package: libavcodec58
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: FFmpeg library with de/encoders for audio/video codecs - runtime files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package contains the runtime files.

Package: libavcodec-extra58
Architecture: any
Section: libs
Multi-Arch: same
Conflicts: libavcodec58
Provides: libavcodec58 (= ${binary:Version})
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: FFmpeg library with additional de/encoders for audio/video codecs
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package replaces the libavcodec58 package and contains the
 following additional codecs:
 .
  * ARIB STD-B24 Captions (Subtitle Decoder)
  * OpenCORE Adaptive Multi-Rate (AMR) Narrow-Band (Encoder/Decoder)
  * OpenCORE Adaptive Multi-Rate (AMR) Wide-Band (Decoder)
  * Android VisualOn Adaptive Multi-Rate (AMR) Wide-Band (Encoder)
 .
 Because this package links against libraries that are licensed under
 Apache License 2.0, the resulting binaries are distributed under the
 GPL version 3 or later.

Package: libavcodec-extra
Architecture: any
Section: metapackages
Multi-Arch: same
Depends:
 libavcodec-extra58 (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library with extra codecs (metapackage)
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This metapackage depends on the latest version of the libavcodec variant
 that offers additional codec support. Application packages can depend
 on it if they require or suggest this variant in a robust manner.


Package: libavcodec-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libavcodec58 (= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 libswresample-dev (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library with de/encoders for audio/video codecs - development files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package contains the development files.

Package: libavdevice58
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: FFmpeg library for handling input and output devices - runtime files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic framework for grabbing from and rendering to
 many common multimedia input/output devices, and supports several input and
 output devices, including Video4Linux2, VfW, DShow, and ALSA.
 .
 This package contains the runtime files.

Package: libavdevice-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libavcodec-dev (= ${binary:Version}),
 libavdevice58 (= ${binary:Version}),
 libavfilter-dev (= ${binary:Version}),
 libavformat-dev (= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 libpostproc-dev (= ${binary:Version}),
 libswscale-dev (= ${binary:Version}),
 libswresample-dev (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library for handling input and output devices - development files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic framework for grabbing from and rendering to
 many common multimedia input/output devices, and supports several input and
 output devices, including Video4Linux2, VfW, DShow, and ALSA.
 .

=== debian/rules ===
#!/usr/bin/make -f

export V=1

# sets DEBIAN_VERSION variable
include /usr/share/dpkg/pkg-info.mk

# Get the Debian version revision:
DEB_REVISION := $(word 2, $(subst -, ,$(DEB_VERSION)))

# sets DEB_HOST_* variables
include /usr/share/dpkg/architecture.mk

# Ubuntu ld adds -Bsymbolic-functions by default, but that prevents FFmpeg from building.
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions

# Package name for the extra flavor.
SHLIB_PKGS := $(shell sed -nr '/extra/! s/^Package:[[:space:]]*(lib.*[0-9]+)[[:space:]]*$$/\1/p' debian/control)
EXTRA_PKGS := $(shell sed -nr 's/^Package:[[:space:]]*(.*extra[0-9]+)[[:space:]]*$$/\1/p' debian/control)
FLAVORS = standard extra static

# Enable as many features as possible, as long as the result is still GPLv2+ (a GPLv3+ variant is built as libavcodec-extra/libavfilter-extra flavor).
# The following flags (and build-dependencies) are not added, because they would require a libavformat-extra flavor:
#   --enable-libglslang             (glslang-dev)
#   --enable-libsmbclient           (libsmbclient-dev [!hurd-i386 !m68k !sparc64])
#   --enable-vulkan                 (libvulkan-dev)
# The following flags are not added, because the necessary libraries are not in Debian:
#   --enable-avisynth               (should link with AviSynth+, embedded avisynth code dropped upstream)
#   --enable-decklink               (see #839941 for discussion of freeness)
#   --enable-libcelt                (see #676592: removed from Debian as abandoned upstream, replaced by opus)
#   --enable-libdavs2               (only in experimental)
#   --enable-libilbc                (see #675959 for the RFP bug)
#   --enable-libklvanc
#   --enable-libkvazaar
#   --enable-libopenh264
#   --enable-librav1e               (see #920842 for the RFP bug)
#   --enable-libtensorflow          (see #959765 for the RFP bug)
#   --enable-libvmaf
#   --enable-libxavs
#   --enable-libxavs2               (only in experimental)
#   --enable-libzimg                (see #864888 for the RFP bug)
#   --enable-vapoursynth            (see #833942 for the RFP bug)
# The following flags are not added for various reasons:
#   --enable-crystalhd              Not usable in Debian (firmware missing from the archive - see #917292)
#   --enable-librtmp                ffmpeg has better built-in RTMP support with listen mode.
#   --enable-mbedtls                Already using gnutls as TLS implementation
#   --enable-libmodplug             see #849840: replaced with libopenmpt
#   --enable-libv4l2                This is only needed for very old devices and may cause problems for others.
#                                   Should anyone need it, using LD_PRELOAD pointing on libv4l2 has the same effect.
#   --enable-opencv                 Does not build with OpenCV >= 3.4 - see <https://trac.ffmpeg.org/ticket/7059>
CONFIG := --prefix=/usr \
	--extra-version="$(DEB_REVISION)" \
	--toolchain=hardened \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	--incdir=/usr/include/$(DEB_HOST_MULTIARCH) \
	--arch=$(DEB_HOST_ARCH_CPU) \
	--enable-gpl \
	--disable-stripping \
	--enable-avresample --disable-filter=resample \
	--enable-gnutls \
	--enable-ladspa \
	--enable-libaom \
	--enable-libass \
	--enable-libbluray \
	--enable-libbs2b \
	--enable-libcaca \
	--enable-libcdio \
	--enable-libcodec2 \
	--enable-libdav1d \
	--enable-libflite \
	--enable-libfontconfig \
	--enable-libfreetype \
	--enable-libfribidi \
	--enable-libgme \
	--enable-libgsm \
	--enable-libjack \
	--enable-libmp3lame \
	--enable-libmysofa \
	--enable-libopenjpeg \
	--enable-libopenmpt \
	--enable-libopus \
	--enable-libpulse \
	--enable-librabbitmq \
	--enable-librsvg \
	--enable-librubberband \
	--enable-libshine \
	--enable-libsnappy \
	--enable-libsoxr \
	--enable-libspeex \
	--enable-libsrt \
	--enable-libssh \
	--enable-libtheora \
	--enable-libtwolame \
	--enable-libvidstab \
	--enable-libvorbis \
	--enable-libvpx \
	--enable-libwavpack \
	--enable-libwebp \
	--enable-libx265 \
	--enable-libxml2 \
	--enable-libxvid \
	--enable-libzmq \
	--enable-libzvbi \
	--enable-lv2 \
	--enable-omx \
	--enable-openal \
	--enable-opencl \
	--enable-opengl \
	--enable-sdl2

# TODO: enable generally when available on mips* (see #812335)
ifeq (,$(filter mips% s390x, $(DEB_HOST_ARCH)))
	CONFIG += --enable-pocketsphinx
endif

ifeq ($(DEB_HOST_ARCH),amd64)
CONFIG += --enable-libmfx
endif

# The standard configuration only uses the shared CONFIG.
CONFIG_standard = --enable-shared

# With these enabled, resulting binaries are effectively licensed as GPLv3+.
CONFIG_extra = --enable-shared \
	--enable-version3 \
	--disable-doc \
	--disable-programs \
	--enable-libaribb24 \
	--enable-liblensfun \
	--enable-libopencore_amrnb \
	--enable-libopencore_amrwb \
	--enable-libtesseract \
	--enable-libvo_amrwbenc

# The static libraries should not be built with PIC.
CONFIG_static = --disable-pic \
	--disable-doc \
	--disable-programs

# Disable optimizations if requested.
ifneq (,$(filter $(DEB_BUILD_OPTIONS),noopt))
	CONFIG += --disable-optimizations
endif

# Respect CC/CXX from the environment, if they differ from the default.
# Don't set them if they equal the default, because that disables autodetection needed for cross-building.
ifneq ($(CC),cc)
	CONFIG += --cc=$(CC)
endif
ifneq ($(CXX),g++)
	CONFIG += --cxx=$(CXX)
endif

# Some libraries are built only on linux.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	CONFIG += --enable-libdc1394 \
		--enable-libdrm \
		--enable-libiec61883
endif

# ffmpeg is involved in build-dependency cycles with x264 and chromaprint, so disable them in stage one.
# Also disable frei0r, which build-depends on opencv.
ifneq ($(filter pkg.ffmpeg.stage1,$(DEB_BUILD_PROFILES)),)
	CONFIG += --disable-frei0r \
		--disable-chromaprint \
		--disable-libx264
else
	CONFIG += --enable-chromaprint \
		--enable-frei0r \
		--enable-libx264
endif

# Disable altivec optimizations on powerpc, because they are not always available on this architecture.
ifeq ($(DEB_HOST_ARCH),powerpc)
	CONFIG += --disable-altivec
	# Build an altivec flavor of the libraries on powerpc.
	# This works around the problem that runtime cpu detection on powerpc currently does not work,
	# because, if altivec is enabled, all files are build with '-maltivec' so that the compiler inserts altivec instructions, wherever it likes.
	CONFIG_altivec = --enable-shared \
		--enable-altivec \
		--disable-doc \
		--disable-programs
	CONFIG_altivec-extra = $(CONFIG_altivec) $(CONFIG_extra)
	FLAVORS += altivec altivec-extra
endif

# Disable assembly optimizations on x32, because they don't work (yet).
ifneq (,$(filter $(DEB_HOST_ARCH),x32))
	CONFIG += --disable-asm
endif

# Disable some optimizations on mips*, because they are not always available on these architectures
ifneq (,$(filter mips%r6 mips%r6el, $(DEB_HOST_ARCH)))
	MIPS_R2_R6_CONFIG = --disable-mips32r2 \
		--disable-mips64r2
else
	MIPS_R2_R6_CONFIG = --disable-mips32r6 \
		--disable-mips64r6
endif

ifneq (,$(filter mips%, $(DEB_HOST_ARCH)))
	CONFIG += --disable-mipsdsp \
		--disable-mipsdspr2 \
		--disable-loongson2 \
		--disable-loongson3 \
		--disable-mmi \
		--disable-mips32r5 \
		$(MIPS_R2_R6_CONFIG) \
		--disable-msa \
		--disable-msa2
endif

# Disable mipsfpu on mips and mipsel, because it is not compatible with the FPXX ABI
ifneq (,$(filter $(DEB_HOST_ARCH),mips mipsel))
	CONFIG += --disable-mipsfpu
endif

# Disable some tests which fail when FLT_EVAL_METHOD != 0 (found on i386, m68k and s390x)
ifneq (,$(filter $(DEB_HOST_ARCH_CPU),i386 m68k s390x))
	CONFIG += --ignore-tests=hapenc-hap-none,hapenc-hapa-none,hapenc-hapq-none
endif

# Set cross-build prefix for compiler, pkg-config...
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CONFIG += --cross-prefix=$(DEB_HOST_GNU_TYPE)- \
		--target-os=$(DEB_HOST_ARCH_OS)
endif

# Use the default debhelper scripts, where possible.
%:
	dh $@ --with pkgkde_symbolshelper

# Add configuration options:
override_dh_auto_configure: $(patsubst %,configure_%,$(FLAVORS))
